#include <stdio.h>
#include <string.h>
#include <propeller.h>
#include <unistd.h>
#include <stdlib.h>

#define P2_TARGET_MHZ 160
#include "sys/p2es_clock.h"
#include "complex.h"
#define BAUD 230400
#define N 128

//////////////////////////////////////////////
// global arrays are needed
// internal by dft
// maybe I let they pass per parameter ?
//////////////////////////////////////////////
int X_real[N];
int X_imag[N];
//////////////////////////////////////////////

void main ()
{
int x[N];
int y[N];
int z[N];
  
  clkset(_SETFREQ, _CLOCKFREQ);
  _setbaud(BAUD);
  sleep(1);

  generate_sin_cos (&x[0], N, 100, 0, 1, 1);  
  generate_sin_cos (&y[0], N, 50, CORDIC_PI_4,10, 0);
  
  for(int n = 0; n < N; n++)
    z[n] = x[n]+y[n];
  
  dft(&z[0],N,&x[0],&y[0]);
  
  inversdft(&z[0],N,&x[0],&y[0]);
  
  for(int n = 0; n < N; n++)
    printf("%d\n",z[n]);
  
}
